<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function get_cdotpro_suboptions_stats() {
  return array(
	       'corporate_stats_type' => array('name' => __('Period', 'cdotpro'), 'type' => 'select')
	       );
}

function get_cdotpro_suboptions_templates() {
  return array(
	       'corporate_template_type' => array('name' => __('Period', 'cdotpro'), 'type' => 'select')
	       );
}


function cdotpro_register_subsettings_stats() {
/*
 * La page des options, et son menu associé
 */
  $cdotpro_suboptions_stats = get_cdotpro_suboptions_stats();
  foreach($cdotpro_suboptions_stats as $opt => $val) {
    register_setting('cdotpro_suboptions_stats', $opt);
  }

}

function cdotpro_register_subsettings_templates() {
/*
 * La page des options, et son menu associé
 */
  $cdotpro_suboptions_templates = get_cdotpro_suboptions_templates();
  foreach($cdotpro_suboptions_templates as $opt => $val) {
    register_setting('cdotpro_suboptions_templates', $opt);
  }

}


/**
 * Create the PRO submenu
 */
function cdotpro_menu() {
  // La page des stats
  add_submenu_page( 'corporate-info-page'
		    , __('Campaing stats', 'cdotpro')
		    , __('Stats', 'cdotpro')
		    , 'manage_options'
		    , 'cdotpro_stats_page'
		    , 'cdotpro_plugin_stats_page'
		    );



  add_action('admin_init', 'cdotpro_register_subsettings_stats');
  add_action('admin_init', 'cdotpro_register_subsettings_templates');

}

add_action( 'admin_menu', 'cdotpro_menu' );


/*
 * La page affichée dans le sous-menu Debug
 */
function cdotpro_plugin_debug_info_page() {

  include_once (CDOTPRO_DIR.'admin/template/cdotpro_debug.php');

}



/*
 * La partie de page consacrée aux bannières dynamiques
 */
function cdotpro_banner_page() {
  ?>
  <!-- Dynamic mode banners -->
   <div id="wes_dynamode">
   <h3><?php _e('Dynamic banner', 'cdotpro'); ?></h3>
    <table class="form-table">
      <tr>
        <th><label for="wes_meta"><?php _e( 'Use static banner', 'cdotpro'); ?></label></th>
        <td>
          <input type="checkbox" name="wes_use_static_if_needed" <?php if (get_option("wes_use_static_if_needed")) { echo "checked='checked' value='".get_option("wes_use_static_if_needed")."'";}; ?> />
  	  <span class="description"><?php _e('Use static banner if none is available', 'cdotpro'); ?></span>
        </td>
      </tr>
    </table>
   
	  <label for="wes_dynamic_category"><?php _e( 'Category filter', 'cdotpro'); ?></label>

<?php
 $wes_banner_category = get_option('wes_banner_category');

 // Show categories ...
 $catArgs = array(
		  'echo' => '0',
		  'show_option_all' => __('All categories', 'cdotpro'),
		  'hide_empty' => '0',
		  // 'show_count' => '1',
		  'name' => 'wes_banner_category',
		  'selected' => $wes_banner_category,
		  );

	$sel = wp_dropdown_categories($catArgs);
	$rep = "<select$1 onchange='return this.form.submit.click()'>";
	$sel  = preg_replace( '#<select([^>]*)>#', $rep, $sel );
	echo $sel;
 ?>
	     
  <h3 class="cpd_posts_title"><?php _e('Posts', 'cdotpro');?></h3>

    <table class="form-table">

	<tr>
    <th><?php _e('Name', 'cdotpro');?></th>
    <th><?php _e('Banner', 'cdotpro');?></th>
    <th><?php _e('Start', 'cdotpro');?></th>
    <th><?php _e('End', 'cdotpro');?></th>
  </tr>

<?php
 
        // Now, the post list ...

/*===========================================================================================
Modifs Gérald - lignes 224 et 226
============================================================================================*/

$screens = get_post_types();
        $postArgs = array(
        'post_type' => $screens,
			  'orderby' => 'date',
			  // 'meta_key' => 'wes_banner_start_date',
			  'category' => $wes_banner_category,
			  'posts_per_page' => -1, //Ajout Gérald
			  'post_status' => 'any',
        'order' => 'ASC',
			  );
	$postsList = get_posts($postArgs);

	// Now, we sort the array using a special filter function
	function postDateSort($a, $b) {
	  $adate = get_post_meta($a->ID, 'wes_banner_start_date', true );
	  $adate = $adate?$adate:mktime(0,0,0,get_the_date("n",$a->ID),get_the_date("j",$a->ID),get_the_date("Y",$a->ID));

	  $bdate = get_post_meta($b->ID, 'wes_banner_start_date', true );
	  $bdate = $bdate?$bdate:mktime(0,0,0,get_the_date("n",$b->ID),get_the_date("j",$b->ID),get_the_date("Y",$b->ID));

	  if ($adate == $bdate) return 0;

	  return ($adate > $bdate)?-1:1;
	}

	usort($postsList, "postDateSort");

	$current_banner_id = cdotpro_get_banner_postID();
	// And for this post list, we should reorder and adapt...
	
	foreach ($postsList as $post) {
	  $img = get_post_meta( $post->ID, 'wes_banner_upload', true );
	  $sdate = get_post_meta($post->ID, 'wes_banner_start_date', true );
	  $edate = get_post_meta($post->ID, 'wes_banner_end_date', true );

	  // No banner ? Skip to next
	  if (! $img) continue;

	  $img = "<img class=\"wpbd_banner\" src=\"".$img."\">";
	  $banner_class = ($current_banner_id == $post->ID)?"current":"possible";
	  echo "<tr class='wes_".$banner_class."_banner'><td class='cpd_post'><a href=\"".get_edit_post_link($post->ID)."\">".$post->post_title."</a></td>";
	  echo "<td><div style='width:200px; height:auto;'>".$img." </div></td>";

	  // The start date (post or banner)
	  if ($sdate) {
	    echo "<td class='wes_banner_date'>".date(__('m/d/Y','cdotpro'), $sdate)."</td>";
	  } else {
	    $pdate = mktime(0,0,0,get_the_date("n",$post->ID),get_the_date("j",$post->ID),get_the_date("Y",$post->ID)) ;
	    echo "<td class='wes_post_date'>".date(__('m/d/Y','cdotpro'), $pdate)."</td>";
	  }

	  // The end date
	  if ($edate) {
	    echo "<td class='wes_banner_date'>".date(__('m/d/Y','cdotpro'), $edate)."</td>";
	  } else {
	    echo "<td>&nbsp;</td>";
	  }

	  // End of row
	  echo "</tr>";
        }
	
?>
    </table>

    </div>

  <?php
}

/*
 * La page affichée dans le sous-menu stats
 */
function cdotpro_plugin_stats_page() {
  global $wpdb;

  if ( !current_user_can( 'manage_options' ) )  {
    wp_die( __( 'You do not have sufficient permissions to access this page.', 'cdotpro' ) );
  }

  // Si le plugin est tout seul ...
  if (! function_exists('wes_getTableName')) {
    wp_die(__('This plugin require CampaingDot plugin installation', 'cdotpro'));
  }
  
  $t_name = wes_getTableName();
  $t_months_name = wes_getMonthsTableName();
  
  // Fonctions appelées dans la page d'affichage des stats

  // Tableau de résultats
  function cdotpro_get_results($q) {
    global $wpdb;

    if (!is_array($q)) {
      return $wpdb->get_results($q);
    } else {
      $r = array();
      foreach ($q as $rq) {
	$r[] = $wpdb->get_results($rq);
      }
      return $r;
    }
  }

  // Tableau de valeurs
  function cdotpro_get_vars($q) {
    global $wpdb;
    
    if (!is_array($q)) {
      return $wpdb->get_var($q);
    } else {
      $r = array();
      foreach ($q as $rq) {
	$r[] = $wpdb->get_var($rq);
      }
      return $r;
    }
  }
?>
    <form method="post" action="options.php">
     <?php settings_fields( 'cdotpro_suboptions_stats' );
	do_settings_sections( 'cdotpro_suboptions_stats' );

	$cdotpro_stats_type = get_option('corporate_stats_type');
	$cdotpro_stats_type = $cdotpro_stats_type?$cdotpro_stats_type:3;

	include_once (CDOTPRO_DIR.'admin/template/cdotpro_displaystats.php');
	?>
    <?php
     // submit_button();
	?>

	  </form>
      <?php
}

///Gérald - templates

function corporate_info_templates() {
  global $wpdb;

  if ( !current_user_can( 'manage_options' ) )  {
    wp_die( __( 'You do not have sufficient permissions to access this page.', 'cdotpro' ) );
  }

  // Si le plugin est tout seul ...
  if (! function_exists('wes_getTableName')) {
    wp_die(__('This plugin require CampaingDot plugin installation', 'cdotpro'));
  }
  
?>
    <form method="post" action="options.php">
     <?php 

	include_once (CDOTPRO_DIR.'admin/template/cdotpro_templates.php');
	?>
    <?php
     // submit_button();
	?>

	  </form>
      <?php
}
//include_once (CDOTPRO_DIR.'admin/wes_templates_menu.php');

