<?php
/*
 * Template loader for Templates submenu *
 * @package: woc_email_signature
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

/*===========================================================================================
Gérald 03/2022 - Templates option page
============================================================================================*/

/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 * 
 */

class Templates {
  private $templates_options;

  public function __construct() {
    add_action( 'admin_menu', array( $this, 'templates_add_plugin_page' ) );
    add_action( 'admin_init', array( $this, 'templates_page_init' ) );
  }

  public function templates_add_plugin_page() {
    add_submenu_page(
        'corporate-info-page', // zzz ajouté pour rendre le sous-menu invisible
      esc_html__( 'Templates', 'cdotpro' ),
            esc_html__( 'Templates', 'cdotpro' ),
            'manage_options',
            'templates',
      array( $this, 'templates_create_admin_page' ) // function
    );
  }

  public function templates_create_admin_page() {
    $this->templates_options = get_option( 'templates_option_name' ); ?>

    <div class="wrap">
      <h2>Templates</h2>
      <p>Create the Email signatures templates here.</p>
      <?php settings_errors(); ?>

      <form method="post" action="options.php">
        <?php
          settings_fields( 'templates_option_group' );
          do_settings_sections( 'templates-admin' );
          submit_button();
        ?>
      </form>
    </div>
  <?php }

  public function templates_page_init() {
    register_setting(
      'templates_option_group', // option_group
      'templates_option_name', // option_name
      array( $this, 'templates_sanitize' ) // sanitize_callback
    );

    add_settings_section(
      'templates_setting_section', // id
      'Settings', // title
      array( $this, 'templates_section_info' ), // callback
      'templates-admin' // page
    );

    add_settings_field(
      'name_of_the_template1_0', // id
      'Name of the template1', // title
      array( $this, 'name_of_the_template1_0_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'html_code1_1', // id
      'HTML code1', // title
      array( $this, 'html_code1_1_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'name_of_the_template2_2', // id
      'Name of the template2', // title
      array( $this, 'name_of_the_template2_2_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'html_code2_3', // id
      'HTML code2', // title
      array( $this, 'html_code2_3_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'name_of_the_template3_4', // id
      'Name of the template3', // title
      array( $this, 'name_of_the_template3_4_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'html_code3_5', // id
      'HTML code3', // title
      array( $this, 'html_code3_5_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'name_of_the_template4_6', // id
      'Name of the template4', // title
      array( $this, 'name_of_the_template4_6_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );

    add_settings_field(
      'html_code4_7', // id
      'HTML code4', // title
      array( $this, 'html_code4_7_callback' ), // callback
      'templates-admin', // page
      'templates_setting_section' // section
    );
  }

  public function templates_sanitize($input) {
    $sanitary_values = array();
    if ( isset( $input['name_of_the_template1_0'] ) ) {
      $sanitary_values['name_of_the_template1_0'] = sanitize_text_field( $input['name_of_the_template1_0'] );
    }

    if ( isset( $input['html_code1_1'] ) ) {
      $sanitary_values['html_code1_1'] = esc_textarea( $input['html_code1_1'] );
    }

    if ( isset( $input['name_of_the_template2_2'] ) ) {
      $sanitary_values['name_of_the_template2_2'] = sanitize_text_field( $input['name_of_the_template2_2'] );
    }

    if ( isset( $input['html_code2_3'] ) ) {
      $sanitary_values['html_code2_3'] = esc_textarea( $input['html_code2_3'] );
    }

    if ( isset( $input['name_of_the_template3_4'] ) ) {
      $sanitary_values['name_of_the_template3_4'] = sanitize_text_field( $input['name_of_the_template3_4'] );
    }

    if ( isset( $input['html_code3_5'] ) ) {
      $sanitary_values['html_code3_5'] = esc_textarea( $input['html_code3_5'] );
    }

    if ( isset( $input['name_of_the_template4_6'] ) ) {
      $sanitary_values['name_of_the_template4_6'] = sanitize_text_field( $input['name_of_the_template4_6'] );
    }

    if ( isset( $input['html_code4_7'] ) ) {
      $sanitary_values['html_code4_7'] = esc_textarea( $input['html_code4_7'] );
    }

    return $sanitary_values;
  }

  public function templates_section_info() {
    
  }

  public function name_of_the_template1_0_callback() {
    printf(
      '<input class="regular-text" type="text" name="templates_option_name[name_of_the_template1_0]" id="name_of_the_template1_0" value="%s">',
      isset( $this->templates_options['name_of_the_template1_0'] ) ? esc_attr( $this->templates_options['name_of_the_template1_0']) : ''
    );
  }

  public function html_code1_1_callback() {
    printf(
      '<textarea class="large-text" rows="5" name="templates_option_name[html_code1_1]" id="html_code1_1">%s</textarea>',
      isset( $this->templates_options['html_code1_1'] ) ? esc_attr( $this->templates_options['html_code1_1']) : ''
    );
  }

  public function name_of_the_template2_2_callback() {
    printf(
      '<input class="regular-text" type="text" name="templates_option_name[name_of_the_template2_2]" id="name_of_the_template2_2" value="%s">',
      isset( $this->templates_options['name_of_the_template2_2'] ) ? esc_attr( $this->templates_options['name_of_the_template2_2']) : ''
    );
  }

  public function html_code2_3_callback() {
    printf(
      '<textarea class="large-text" rows="5" name="templates_option_name[html_code2_3]" id="html_code2_3">%s</textarea>',
      isset( $this->templates_options['html_code2_3'] ) ? esc_attr( $this->templates_options['html_code2_3']) : ''
    );
  }

  public function name_of_the_template3_4_callback() {
    printf(
      '<input class="regular-text" type="text" name="templates_option_name[name_of_the_template3_4]" id="name_of_the_template3_4" value="%s">',
      isset( $this->templates_options['name_of_the_template3_4'] ) ? esc_attr( $this->templates_options['name_of_the_template3_4']) : ''
    );
  }

  public function html_code3_5_callback() {
    printf(
      '<textarea class="large-text" rows="5" name="templates_option_name[html_code3_5]" id="html_code3_5">%s</textarea>',
      isset( $this->templates_options['html_code3_5'] ) ? esc_attr( $this->templates_options['html_code3_5']) : ''
    );
  }

  public function name_of_the_template4_6_callback() {
    printf(
      '<input class="regular-text" type="text" name="templates_option_name[name_of_the_template4_6]" id="name_of_the_template4_6" value="%s">',
      isset( $this->templates_options['name_of_the_template4_6'] ) ? esc_attr( $this->templates_options['name_of_the_template4_6']) : ''
    );
  }

  public function html_code4_7_callback() {
    printf(
      '<textarea class="large-text" rows="5" name="templates_option_name[html_code4_7]" id="html_code4_7">%s</textarea>',
      isset( $this->templates_options['html_code4_7'] ) ? esc_attr( $this->templates_options['html_code4_7']) : ''
    );
  }

}
if ( is_admin() )
  $templates = new Templates();

/* 
 * Retrieve this value with:
 * $templates_options = get_option( 'templates_option_name' ); // Array of All Options
 * $name_of_the_template1_0 = $templates_options['name_of_the_template1_0']; // Name of the template1
 * $html_code1_1 = $templates_options['html_code1_1']; // HTML code1
 * $name_of_the_template2_2 = $templates_options['name_of_the_template2_2']; // Name of the template2
 * $html_code2_3 = $templates_options['html_code2_3']; // HTML code2
 * $name_of_the_template3_4 = $templates_options['name_of_the_template3_4']; // Name of the template3
 * $html_code3_5 = $templates_options['html_code3_5']; // HTML code3
 * $name_of_the_template4_6 = $templates_options['name_of_the_template4_6']; // Name of the template4
 * $html_code4_7 = $templates_options['html_code4_7']; // HTML code4
 */



