<?php
/*
Plugin Name: CampaignDotPro
Plugin URI: http://campaigndot.com
Description: The CampaignDotPro plugin add some features to CampaignDot. A stats page allow you to check the relevance of your marketing campaign.
Depends: CampaignDot
Version: 1.2.5
Author: CampaignDot
Author URI: http://www.campaigndot.com/
Text Domain: cdotpro
Domain Path: /languages
License: GPLv2
*/

// Exit if accessed directly
defined( 'ABSPATH' ) OR	exit;

define('CDOTPRO_URL', plugin_dir_url( __FILE__ ));
define('CDOTPRO_DIR', plugin_dir_path( __FILE__ ));
define('CDOTPRO_FILE', __FILE__);
// define('CDOTPRO_DEBUG', true);
define('CDOTPRO_VERSION', trim(preg_replace('/^Version: /', '', implode('',preg_grep('/^Version: .*/', file(__FILE__))))));

//Ajout Gérald - licensing 2022
require_once "include/CampaignDotProunlimitedBase.php";
class CampaignDotProunlimited {
    public $plugin_file=__FILE__;
    public $responseObj;
    public $licenseMessage;
    public $showMessage=false;
    public $slug="cdotpro";
    function __construct() {
        add_action( 'admin_print_styles', [ $this, 'SetAdminStyle' ] );
        $licenseKey=get_option("CampaignDotProunlimited_lic_Key","");
        $liceEmail=get_option( "CampaignDotProunlimited_lic_email","");
        CampaignDotProunlimitedBase::addOnDelete(function(){
           delete_option("CampaignDotProunlimited_lic_Key");
        });
        if(CampaignDotProunlimitedBase::CheckWPPlugin($licenseKey,$liceEmail,$this->licenseMessage,$this->responseObj,__FILE__)){
            add_action( 'admin_menu', [$this,'ActiveAdminMenu'],99999);
            add_action( 'admin_post_CampaignDotProunlimited_el_deactivate_license', [ $this, 'action_deactivate_license' ] );
            //$this->licenselMessage=$this->mess;

//***Plugin's code below - Gérald 28/03/2022***

/*
 * Traductions
 */

// Je ne sais pas (encore) comment dire à poedit d'aller chercher un texte en commentaire, donc voilà...
define('CDOTPRO_DESCRIPTION', __('The CampaignDotPro plugin add some features to CampaignDot. A stats page allow you to check the relevance of your marketing campaign.', 'cdotpro'));

function cdotpro_language_load() {
  load_plugin_textdomain('cdotpro', FALSE, basename(CDOTPRO_DIR) . '/languages');
}
add_action('init', 'cdotpro_language_load');


/*
 * Les mises à jour // Ajout Gérald 3/3/2022
 */

/*require 'include/plugin-update-checker/plugin-update-checker.php';
$MyUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
  'https://www.campaigndot.com/cpd_versions/wp-update-server/?action=get_metadata&slug=campaigndotpro', //Metadata URL.
  __FILE__, //Full path to the main plugin file.
  'campaigndotpro' //Plugin slug. Usually it's the same as the name of the directory.
);
*/



/*
 * Les styles et scripts
 */

function cdotpro_scripts() {
  wp_enqueue_style( 'cdotpro-style', CDOTPRO_URL . 'css/styles.css');
};

function cdotpro_admin_scripts() {
  // wp_enqueue_style( 'cdotpro-c3-style', CDOTPRO_URL . 'css/c3.css');
  wp_enqueue_style( 'cdotpro-c3-min-style', CDOTPRO_URL . 'css/c3.min.css');
  // wp_enqueue_script( 'cdotpro-c3-script', CDOTPRO_URL . 'js/c3.js');
  wp_enqueue_script( 'cdotpro-c3-min-script', CDOTPRO_URL . 'js/c3.min.js');
  wp_enqueue_script( 'cdotpro-d3-script', CDOTPRO_URL . 'js/d3.v3.min.js');
}
         
add_action('wp_enqueue_scripts', 'cdotpro_scripts');
add_action('admin_enqueue_scripts', 'cdotpro_scripts');
add_action('admin_enqueue_scripts', 'cdotpro_admin_scripts');


/*
 * Puis on va inclure les fichiers du plugin
 */
include_once (CDOTPRO_DIR.'admin/cdotpro_optionsmenu.php');
include_once (CDOTPRO_DIR.'cdotpro_signature.php');


// On teste la présence du plugin CampaignDot avant de faire quoi que ce soit
//
function cdot_depend_error() {
  $class="notice notice-warning is-dismissible";
  $message=sprintf(__('CampaignDotPro plugin need CampaignDot installed and activated. Visit <a href="%1$s">Wordpress site</a> for more infos.','cdotpro'), "http://wordpress.org/plugins/campaigndot/" );

    
  if (get_option("cdot_active", false) == false)
    printf('<div class="%1$s"><p>%2$s</p></div>', $class, $message);
}

add_action('admin_notices', 'cdot_depend_error');


/**
 * Check if cdot is active or not
 */
function check_cdot_active() {
  if(is_plugin_active("campaigndot/campaigndot.php")) {
    update_option("cdot_active", true);
  } else {
   delete_option("cdot_active");
  }
}

add_action('admin_init', 'check_cdot_active');


// La fonction de mise en place du désinstalleur
function cdotpro_uninstall_hook() {
  // register_uninstall_hook( __FILE__ , 'cdotpro_deleteDBTables' );
  // register_uninstall_hook( __FILE__ , 'cdotpro_cleanTransient' );
}
register_activation_hook( __FILE__ , 'cdotpro_uninstall_hook' );

















        }else{
            if(!empty($licenseKey) && !empty($this->licenseMessage)){
               $this->showMessage=true;
            }
            update_option("CampaignDotProunlimited_lic_Key","") || add_option("CampaignDotProunlimited_lic_Key","");
            add_action( 'admin_post_CampaignDotProunlimited_el_activate_license', [ $this, 'action_activate_license' ] );
            add_action( 'admin_menu', [$this,'InactiveMenu']);
        }
    }
    function SetAdminStyle() {
        wp_register_style( "CampaignDotProunlimitedLic", plugins_url("css/_lic_style.css",$this->plugin_file),10);
        wp_enqueue_style( "CampaignDotProunlimitedLic" );
    }
    function ActiveAdminMenu(){
        
// add_menu_page (  "CampaignDotProunlimited", "CampaignDot Pro unlimited", "activate_plugins", $this->slug, [$this,"Activated"], " dashicons-star-filled ");
  add_submenu_page(  
    "corporate-info-page",  
    "CampaignDotProunlimited", 
    "License Info", 
    "activate_plugins", 
    $this->slug, 
    [$this,"Activated"],
     null
    
);

    }
    function InactiveMenu() {
     //   add_menu_page( "CampaignDotProunlimited", "CampaignDot Pro unlimited", 'activate_plugins', $this->slug,  [$this,"LicenseForm"], " dashicons-star-filled " );
            add_submenu_page(  
                "corporate-info-page", 
                "CampaignDotProunlimited License", 
                "License Info", 
                'activate_plugins', 
                $this->slug,  
                [$this,"LicenseForm"],
                 null
            );


    }
    function action_activate_license(){
        check_admin_referer( 'el-license' );
        $licenseKey=!empty($_POST['el_license_key'])?$_POST['el_license_key']:"";
        $licenseEmail=!empty($_POST['el_license_email'])?$_POST['el_license_email']:"";
        update_option("CampaignDotProunlimited_lic_Key",$licenseKey) || add_option("CampaignDotProunlimited_lic_Key",$licenseKey);
        update_option("CampaignDotProunlimited_lic_email",$licenseEmail) || add_option("CampaignDotProunlimited_lic_email",$licenseEmail);
        update_option('_site_transient_update_plugins','');
        wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }
    function action_deactivate_license() {
        check_admin_referer( 'el-license' );
        $message="";
        if(CampaignDotProunlimitedBase::RemoveLicenseKey(__FILE__,$message)){
            update_option("CampaignDotProunlimited_lic_Key","") || add_option("CampaignDotProunlimited_lic_Key","");
            update_option('_site_transient_update_plugins','');
        }
        wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }
    function Activated(){
        ?>
        <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="CampaignDotProunlimited_el_deactivate_license"/>
            <div class="el-license-container">
                <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php _e("CampaignDot Pro unlimited License Info",$this->slug);?> </h3>
                <hr>
                <ul class="el-license-info">
                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("Status",$this->slug);?></span>

                        <?php if ( $this->responseObj->is_valid ) : ?>
                            <span class="el-license-valid"><?php _e("Valid",$this->slug);?></span>
                        <?php else : ?>
                            <span class="el-license-valid"><?php _e("Invalid",$this->slug);?></span>
                        <?php endif; ?>
                    </div>
                </li>

                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("License Type",$this->slug);?></span>
                        <?php echo $this->responseObj->license_title; ?>
                    </div>
                </li>

               <li>
                   <div>
                       <span class="el-license-info-title"><?php _e("License Expired on",$this->slug);?></span>
                       <?php echo $this->responseObj->expire_date;
                       if(!empty($this->responseObj->expire_renew_link)){
                           ?>
                           <a target="_blank" class="el-blue-btn" href="<?php echo $this->responseObj->expire_renew_link; ?>">Renew</a>
                           <?php
                       }
                       ?>
                   </div>
               </li>

               <li>
                   <div>
                       <span class="el-license-info-title"><?php _e("Support Expired on",$this->slug);?></span>
                       <?php
                           echo $this->responseObj->support_end;
                        if(!empty($this->responseObj->support_renew_link)){
                            ?>
                               <a target="_blank" class="el-blue-btn" href="<?php echo $this->responseObj->support_renew_link; ?>">Renew</a>
                            <?php
                        }
                       ?>
                   </div>
               </li>
                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("Your License Key",$this->slug);?></span>
                        <span class="el-license-key"><?php echo esc_attr( substr($this->responseObj->license_key,0,9)."XXXXXXXX-XXXXXXXX".substr($this->responseObj->license_key,-9) ); ?></span>
                    </div>
                </li>
                </ul>
                <div class="el-license-active-btn">
                    <?php wp_nonce_field( 'el-license' ); ?>
                    <?php submit_button('Deactivate'); ?>
                </div>
            </div>
        </form>
    <?php
    }

    function LicenseForm() {
        ?>
    <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
        <input type="hidden" name="action" value="CampaignDotProunlimited_el_activate_license"/>
        <div class="el-license-container">
            <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php _e("CampaignDot Pro unlimited Licensing",$this->slug);?></h3>
            <hr>
            <?php
            if(!empty($this->showMessage) && !empty($this->licenseMessage)){
                ?>
                <div class="notice notice-error is-dismissible">
                    <p><?php echo _e($this->licenseMessage,$this->slug); ?></p>
                </div>
                <?php
            }
            ?>
            <p><?php _e("Enter your license key here, to activate the product, and get full feature updates and premium support.",$this->slug);?></p>
<ol>
    <li><?php _e("Write your licnese key details",$this->slug);?></li>
    <li><?php _e("How buyer will get this license key?",$this->slug);?></li>
    <li><?php _e("Describe other info about licensing if required",$this->slug);?></li>
    <li>. ...</li>
</ol>
            <div class="el-license-field">
                <label for="el_license_key"><?php _e("License code",$this->slug);?></label>
                <input type="text" class="regular-text code" name="el_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
            </div>
            <div class="el-license-field">
                <label for="el_license_key"><?php _e("Email Address",$this->slug);?></label>
                <?php
                    $purchaseEmail   = get_option( "CampaignDotProunlimited_lic_email", get_bloginfo( 'admin_email' ));
                ?>
                <input type="text" class="regular-text code" name="el_license_email" size="50" value="<?php echo $purchaseEmail; ?>" placeholder="" required="required">
                <div><small><?php _e("We will send update news of this product by this email address, don't worry, we hate spam",$this->slug);?></small></div>
            </div>
            <div class="el-license-active-btn">
                <?php wp_nonce_field( 'el-license' ); ?>
                <?php submit_button('Activate'); ?>
            </div>
        </div>
    </form>
        <?php
    }
}

new CampaignDotProunlimited();


