<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
  exit;
}


/*
 * On recherche le post qui pourrait contenir la bannière
 */
function cdotpro_get_banner_postID($userID = 0) {

  // On va récupérer une liste de catégories...
  $wes_category_mode = get_the_author_meta('wes_category_mode', $userID);
  $wes_banner_categories = get_the_author_meta('wes_banner_categories', $userID);

  if ($wes_category_mode == "include") {
    // Only posts in specific categories
    $catList = $wes_banner_categories;
  } else {
    // Create a list of categories excluding $wes_banner_categories;
    $catArray = get_terms('category',
			 array(
			       'hide_empty' => false,
			       'fields' => 'id=>name',
			       'exclude' => $wes_banner_categories,
			       )
			 );
    $cArray = array();
    foreach ($catArray as $id => $name) $cArray[] = $id;
    $catList = implode(",",$cArray);
  }
  
  // On va récupérer les posts afin de déterminer
  // Now, the post list ...

/*===========================================================================================
Modifs Gérald - lignes 42, 44 et mise en commentaire de la ligne 46 (pas optimal, mais pas indispensable).
============================================================================================*/

  $screens = get_post_types();
  $postArgs = array(
        'post_type' => $screens,
		    'orderby' => 'date',
		  //  'category' => $catList,
		    'post_status' => 'any',
		    'posts_per_page' => -1,
		    );
  $postsList = get_posts($postArgs);

  // Then, find the post with date closer to current date, and with a banner
  $curr_date = time();
  $good_date = mktime(0,0,0,1,1,1975);
  $good_post = 0;

  foreach($postsList as $post) {
    $img = get_post_meta( $post->ID, 'wes_banner_upload', true );
    $sdate = get_post_meta($post->ID, 'wes_banner_start_date', true );
    $edate = get_post_meta($post->ID, 'wes_banner_end_date', true );

    // Si il n'y a pas d'image, alors on passe au suivant.
    if (!$img) continue;
    
    // If no date, then pickup post date
    if ($sdate) {
      $pdate = $sdate;
    } else {
      $pdate = mktime(0,0,0,get_the_date("n",$post->ID),get_the_date("j",$post->ID),get_the_date("Y",$post->ID)) ;
    }
    
    // If the post sdate is before now, and sdate is after the best already found date
    if (($pdate < $curr_date) && ($pdate > $good_date)) {
      // No end date or end date not reached ?
      if (!$edate || ($edate+24*60*60 > $curr_date)) {
	$good_post = $post->ID;
	$good_date = $pdate;
      }
    }

  }

  // Then return the good post id, or 0
  return $good_post;

}
